package com.eactive.eai.batch.job.jobItem.ftbat;

import java.io.ByteArrayOutputStream;

import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.common.exception.ExceptionUtil;

public class RECV_FTBAT_0230 extends DefaultTelegram implements TelegramService
{

    /**
     * 생성자
     */
    public RECV_FTBAT_0230() {
    }

    /**
     * 전문 해체하기
     */
    public boolean doExecute() {
        if (!super.doExecute()) return false;
        try {
            String _size  = new String ((byte[]) al_Field.get(2));
            int recv_size = Integer.parseInt(_size);

            if (recv_size != batchDoc.getBatchMsg().getBody().getCurFileSize() ){
            	setResolveResponseCode("F002");
            	batchDoc.getBatchMsg().getBody().setErrorMsg("수신된 파일 사이즈[" + batchDoc.getBatchMsg().getBody().getCurFileSize()+ "]");
            }else{
            	setResolveResponseCode("0000");
            }

        } catch ( Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    /**
     * 전문 Validation
     */
    public boolean doValidation()
    {
        if (!super.doValidation()) return false;

        return true;
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        try {
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=1; i<2; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=2; i< al_Field.size()-1; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));
            return true;
        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(1);
    }
//    // 거래구분코드 필드값 리턴
//    public String getTrClass()
//    {
//        return super.getFieldValueString(4);
//    }
//    //응답코드 필드값 리턴
//    public String getResCode()
//    {
//        return super.getFieldValueString(7);
//    }
//    //업무관리코드 필드값 리턴
//    public String getOpCode()
//    {
//        return super.getOpCode();
//    }
}